function generujSitDesek
n1 = 7;
n2 = 7;
n3 = 10;

lx = 2;
ly = 1;
lz = 0.5;

display(['Pocet bunek site je: ', num2str(n1*n2*n3)]);

X = zeros(n1+1,n2+1,n3+1);
Y = zeros(n1+1,n2+1,n3+1);
Z = zeros(n1+1,n2+1,n3+1);

% deska
Xp = zeros(n1+1,n2+1);
Yp = zeros(n1+1,n2+1);

x = linspace(0,lx,n1+1);
y = linspace(0,ly,n2+1);
for i = 1:n1+1
    for j = 1:n2+1
        Xp(i,j) = x(i);
        Yp(i,j) = y(j);
    end
end

z = linspace(0,lz,n3+1);
I = 1:n1+1;
J = 1:n2+1;
for k = 1:n3+1
    X(I,J,k) = Xp;
    Y(I,J,k) = Yp;
    Z(I,J,k) = z(k);
end

ind = zeros(n1+1,n2+1,n3+1);
P = zeros((n1+1)*(n2+1)*(n3+1),3);
s = 1;
for i = 1:n1+1
    for j = 1:n2+1
        for k = 1:n3+1
            ind(i,j,k) = s;
            P(s,:) = [X(i,j,k),Y(i,j,k),Z(i,j,k)];
            s = s + 1;
        end
    end
end

nq = n1*n2*n3;
QP = zeros(nq,8);
indQ = zeros(n1,n2,n3);
s = 1;
for i = 1:n1
    for j = 1:n2
        for k = 1:n3
            v = [ind(i,j,k),ind(i+1,j,k),ind(i+1,j+1,k),ind(i,j+1,k),ind(i,j,k+1),ind(i+1,j,k+1),ind(i+1,j+1,k+1),ind(i,j+1,k+1)];
            QP(s,:) = v;
            indQ(i,j,k) = s-1;
            s = s + 1;
        end
    end
end

QQ = zeros(nq,6);
TEshift = zeros(size(QQ));
s = 1;
for i = 1:n1
    for j = 1:n2
        for k = 1:n3
            if(k == 1)
                QQ(s,1) = -1;
            else
                QQ(s,1) = indQ(i,j,k-1);
            end
            if(k == n3)
                QQ(s,2) = -1;
            else
                QQ(s,2) = indQ(i,j,k+1);
            end
            
            if(i == 1)
                QQ(s,6) = -2;
            else
                QQ(s,6) = indQ(i-1,j,k);
            end
            if(i == n1)
                QQ(s,4) = -3;
            else
                QQ(s,4) = indQ(i+1,j,k);
            end
            
            if(j == 1)
                QQ(s,3) = indQ(i,n2,k);
                TEshift(s,3) = 3;
            else
                QQ(s,3) = indQ(i,j-1,k);
            end
            if(j == n2)
                QQ(s,5) = indQ(i,1,k);
                TEshift(s,5) = 4;
            else
                QQ(s,5) = indQ(i,j+1,k);
            end
            s = s + 1;
        end
    end
end

shift = [lx 0 0; -lx 0 0; 0 ly 0; 0 -ly 0];

dlmwrite('mesh/vertices.txt', P, 'delimiter', ' ', 'precision', 16);
save2File('mesh/elements.txt',QP-1)
save2File('mesh/neighbors.txt',QQ)
save2File('mesh/elementType.txt',6*ones(length(QQ(:,1)),1))
dlmwrite('mesh/TEshift.txt', TEshift, 'delimiter', ' ');
dlmwrite('mesh/shift.txt', shift, 'delimiter', ' ');

if(1 == 1)
    figure;
    hold on;
    for k = 1:n3;
        for i = 1:n1
            plot3(X(i,:,k),Y(i,:,k),Z(i,:,k),'b');
        end
        for j = 1:n2
            plot3(X(:,j,k),Y(:,j,k),Z(:,j,k),'b');
        end
    end
    axis equal;
end


function save2File(name,A)
fid = fopen(name,'w');
[m,n] = size(A);
for i = 1:m
    for j = 1:n
        fprintf(fid,'%i ',A(i,j));
    end
    fprintf(fid,'\n');
end
fclose(fid);









